/**
  Modificăm puțin problema ACSL Tiles - Contest#1,
Junior - 2023/2024 astfel ca citirea datelor să
poate fi făcută mai ușor

Și anume:
- citim un număr de 4 cifre, care reprezintă
  numărul cu care începe fiecare rând.
- citim apoi un șir de numere cu exact 2 cifre
fiecare, care reprezintă piesele ce se dau.
Șirul se termină dacă băgăm 0.
Pe exemplul dat în problemă se citesc așa:
5923
56 85 27 73 14 34 62 0
*/
#include <iostream>
using namespace std;

int main()
{
    int rows,r1,r2,r3,r4,tile,c1,c2,discard_sum=0;
    ///rows=primul număr citit
    ///r1, r2, r3, r4 = în ele reținem ultimul număr
    ///    adică cel cu care se termină fiecare dintre
    ///    cele 4 rânduri
    ///  tile = piesa curentă (formată din 2 cifre)
    ///  c1, c2 = cifrele din piesa curentă
    ///  discard_sum = suma rezultat
    cin>>rows;
    r1=rows/1000;
    r2=rows/100%10;
    r3=rows/10%10;
    r4=rows%10;
    ///pregătim citirea pieselor: citim în mod repetat
    ///valori până se introduce 0:
    cin>>tile;
    while(tile!=0)
    {
        ///separăm cifrele de pe tile:
        c1=tile/10;
        c2=tile%10;
        ///verificăm toate potrivirile posibile
        ///începem cu r1:
        if(r1==c1)r1=c2;
        else if(r1==c2)r1=c1;
        else if(r2==c1)r2=c2;
        else if(r2==c2)r2=c1;
        else if(r3==c1)r3=c2;
        else if(r3==c2)r3=c1;
        else if(r4==c1)r4=c2;
        else if(r4==c2)r4=c1;
        else discard_sum+=c1+c2;
        cin>>tile;
    }
    cout<<discard_sum;
    return 0;
}
